#include <glut.h>
#include <math.h>
#define GL_PI 3.1415

GLfloat OX = 200;
GLfloat OY = 200;
GLfloat OZ = 200;

GLfloat xRot = 50.0f;
GLfloat yRot = 20.0f;
GLfloat x, y, z, angel;

GLfloat sizes[2];// 
GLfloat step;//   
GLfloat curSize;//  


void Draw()
{
	glClear(GL_COLOR_BUFFER_BIT);//     
	glBegin(GL_LINE);
	glNormal3f(0.0, 1.0, 0.0);//       ,
	//         
	//    glPushMatrix()  glPopMatrix()
	glEnd();
	glPushMatrix();// 
	glRotatef(xRot, 0.0f, 1.0f, 0.0f);
	glRotatef(yRot, 0.0f, 1.0f, 1.0f);
	glGetFloatv(GL_POINT_SIZE_RANGE, sizes);//       Sizes [0],        Sizes [ 1 ]
	glGetFloatv(GL_POINT_SIZE_GRANULARITY, &step);//      
	//   
	curSize = sizes[0];
	z = -100.0f;	
	for (angel = 0.0f; angel <= (2.0f*GL_PI)*3.0f; angel += 0.1f)
	{
		x = 100.0f*sin(angel);
		y = 100.0f*cos(angel);
		glPointSize(curSize);
		glBegin(GL_POINTS);
		glColor3ub(255, 128, 0);//
		glVertex3f(x, y, z);// 
		glEnd();
		z += 1.0f;
		curSize += step;
	}
	glEnd();
	glPopMatrix();// 
	glutSwapBuffers();//      
}

void Timer(int)
{
	xRot++;
	glutPostRedisplay();//    Draw()
	glutTimerFunc(20, Timer, 1);
}

void Timer2(int)
{
	yRot++;
	glutPostRedisplay();
	glutTimerFunc(10, Timer2, 1);
}

void Init()
{
	glClearColor(0.0, 0.0, 0.0, 1.0);
	glMatrixMode(GL_PROJECTION);//  - 
	glLoadIdentity();// 
	glOrtho(-OX, OX, -OY, OY, -OZ, OZ);// 3     
	glMatrixMode(GL_MODELVIEW);

}

float ambient[] = {0.3, 0.3, 0.3, 1.0};
float diffuse[] = { 1.0, 1.0, 1.0, 1.0 };
float black[] = {0.0, 0.0, 0.0, 1.0};
float lpos[] = {OX, 0, 0, 1.0};

int main(int argc, char** argv)//-    ,      
{
	//
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(2*OX, 2*OY);
	glutInitWindowPosition(500, 200);
	//glShadeModel(GL_SMOOTH);//     FLAT-    
	glutCreateWindow("3D scene");
	//
	glutDisplayFunc(Draw);
	glutTimerFunc(20, Timer, 1);
	glutTimerFunc(10, Timer2, 1);
	glEnable(GL_POINT_SMOOTH);//      

	glEnable(GL_LIGHTING);//
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, black);//  
	glEnable(GL_LIGHT0);//  
	glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);//  
	glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);//  
	glLightfv(GL_LIGHT0, GL_POSITION, lpos);//   lpos
	glEnable(GL_COLOR_MATERIAL);//    
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);//  ,   

	Init();
	glutMainLoop();/*     */
	return 0;
}